<template>
    <div class="outils">
        <div
            class="rangOutils uk-flex uk-flex-center"
            v-if="this.etatEdition.isConfiguration()"
        >
            <button
                class="uk-button uk-button-default"
                @click="afficherPierresNoires()"
            >
                Pierres Noires
            </button>
            <button
                class="uk-button uk-button-default uk-margin-small-left"
                @click="afficherPierresBlanches()"
            >
                Pierres Blanches
            </button>
        </div>
        <div class="rangOutils uk-flex uk-flex-center" v-else>
            <button
                class="uk-button uk-button-default"
                @click="afficherPierres()"
            >
                Pierres
            </button>
            <button
                class="uk-button uk-button-default uk-margin-small-left"
                @click="supprimerPierres()"
            >
                Supprimer
            </button>
        </div>
        <div class="rangOutils uk-flex uk-flex-center">
            <button
                class="uk-button uk-button-default"
                @click="afficherCarre()"
            >
                Carré
            </button>
            <button
                class="uk-button uk-button-default uk-margin-small-left"
                @click="afficherRond()"
            >
                Rond
            </button>
            <button
                class="uk-button uk-button-default uk-margin-small-left"
                @click="afficherTriangle()"
            >
                Triangle
            </button>
        </div>
        <div class="rangOutils uk-flex uk-flex-center">
            <button
                class="uk-button uk-button-default"
                @click="afficherTexte()"
            >
                Texte
            </button>
            <button
                class="uk-button uk-button-default uk-margin-small-left"
                @click="afficherNombre()"
            >
                Nombre
            </button>
        </div>
        <div class="uk-margin">
            Commentaire
            <textarea class="uk-textarea" v-model="commentaire" />
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { Component } from 'vue-property-decorator';
import { getInstanceEtatEdition } from './EtatEdition';
import supprimerVariation from './SuppressionVariation';
@Component
export default class OutilsGoban extends Vue {
    private commentaire = '';
    private etatEdition: any;
    private keyControlDown: boolean;

    created() {
        this.etatEdition = getInstanceEtatEdition();
        this.$root.$on('modifierPosition', () => this.afficherCommentaire());
        this.$root.$on('initPosition', () => this.afficherCommentaire());
        this.$root.$on('enregistrerCommentaire', () =>
            this.etatEdition.enregistrerCommentaire(this.commentaire)
        );
    }

    mounted() {
        this.commentaire = this.retirerBalisesHTML(
            this.etatEdition.commentaireInitial
        );
        this.keyControlDown = false;
        document.addEventListener('keydown', e => {
            if (e.key == 'Control') {
                if (!this.keyControlDown) {
                    this.pressCtrl();
                }
                this.keyControlDown = true;
            }
        });

        document.addEventListener('keyup', e => {
            if (e.key == 'Control') {
                this.keyControlDown = false;
                this.pressCtrl();
            }
        });
    }

    private pressCtrl() {
        if (this.etatEdition.outilEnCours === 'Noir') {
            this.etatEdition.setListenerPierresBlanches();
        } else if (this.etatEdition.outilEnCours === 'Blanc') {
            this.afficherPierresNoires();
        }
    }

    private afficherCommentaire() {
        if (this.etatEdition.getIndexPierre() === -1) {
            this.commentaire = this.retirerBalisesHTML(
                this.etatEdition.commentaireInitial
            );
        } else {
            this.commentaire = this.retirerBalisesHTML(
                this.etatEdition.coupEnCours.getCommentaire()
            );
        }
    }

    private retirerBalisesHTML(texte: string): string {
        return texte ? texte.replaceAll('<br/>', '\r\n') : texte;
    }

    private afficherPierresNoires() {
        this.etatEdition.setListenerPierresNoires();
    }

    private afficherPierresBlanches() {
        this.etatEdition.setListenerPierresBlanches();
    }

    private afficherPierres() {
        this.etatEdition.setListenerPierres();
    }

    private afficherCarre() {
        this.etatEdition.setListenerCarre();
    }

    private afficherRond() {
        this.etatEdition.setListenerCercle();
    }

    private afficherTriangle() {
        this.etatEdition.setListenerTriangle();
    }

    private afficherTexte() {
        this.etatEdition.setListenerTexte();
    }

    private afficherNombre() {
        this.etatEdition.setListenerNombre();
    }

    private supprimerPierres() {
        supprimerVariation();
        const marqueurs = this.etatEdition.possibiliteEnCours.getMarqueurs();
        marqueurs
            .filter(
                marqueur =>
                    marqueur.getPosition() >= this.etatEdition.getIndexPierre()
            )
            .forEach(marqueur =>
                marqueurs.splice(marqueurs.indexOf(marqueur), 1)
            );
        this.etatEdition.varierCoupEnCours(false);
        this.$root.$emit('modifierPosition', true);
        this.$root.$emit('initPosition');
    }
}
</script>

<style scoped>
.rangOutils {
    margin-top: 10px;
}
</style>
